From d305efbdbae5f28a7c7e4888f2ed413e6d9739cb Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: May 10 2017 07:28:34 +0000
Subject: [PATCH 836/1001] Reorganize the utils modules to avoid circular imports


---

diff --git a/hubs/tests/test_view_utils.py b/hubs/tests/test_view_utils.py
index d445c28..64b6aee 100644
--- a/hubs/tests/test_view_utils.py
+++ b/hubs/tests/test_view_utils.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import hubs.models
 from hubs.app import app
 from hubs.tests import APPTest, FakeAuthorization, auth_set
-from hubs.views.utils import get_visible_widgets
+from hubs.utils.views import get_visible_widgets
 
 
 class ViewUtilsTest(APPTest):
diff --git a/hubs/utils/__init__.py b/hubs/utils/__init__.py
new file mode 100755
index 0000000..8713806
--- /dev/null
+++ b/hubs/utils/__init__.py
@@ -0,0 +1,26 @@
+from __future__ import unicode_literals
+
+import os
+from hashlib import sha256
+
+import fedmsg.config
+import fedmsg.meta
+from six.moves.urllib_parse import urlencode
+
+
+def get_fedmsg_config():
+    try:
+        filenames = [os.environ["FEDMSG_CONFIG"]]
+    except KeyError:
+        filenames = None
+    fedmsg_config = fedmsg.config.load_config(filenames=filenames)
+    fedmsg.meta.make_processors(**fedmsg_config)
+    return fedmsg_config
+
+
+def username2avatar(username, s=312):
+    query = urlencode([('s', s), ('d', 'retro')])
+    openid = 'http://%s.id.fedoraproject.org/' % username
+    hash = sha256(openid.encode('utf-8')).hexdigest()
+    avatar = "https://seccdn.libravatar.org/avatar/%s?%s" % (hash, query)
+    return avatar
diff --git a/hubs/utils/github.py b/hubs/utils/github.py
new file mode 100644
index 0000000..47c1018
--- /dev/null
+++ b/hubs/utils/github.py
@@ -0,0 +1,59 @@
+from __future__ import unicode_literals
+
+import logging
+
+import arrow
+import requests
+
+
+log = logging.getLogger(__name__)
+
+
+def github_repos(token, username):
+    log.info("Finding github repos for %r" % username)
+    tmpl = "https://api.github.com/users/{username}/repos?per_page=100"
+    url = tmpl.format(username=username)
+    auth = dict(access_token=token)
+    for result in _github_results(url, auth):
+        yield result['name']
+
+
+def github_pulls(token, username, repo):
+    log.info("Finding github pull requests for %r %r" % (username, repo))
+    tmpl = "https://api.github.com/repos/{username}/{repo}/" + \
+        "pulls?per_page=100"
+    url = tmpl.format(username=username, repo=repo)
+    auth = dict(access_token=token)
+    for result in _github_results(url, auth):
+        yield dict(
+            user=result['user']['login'],
+            title=result['title'],
+            url=result['html_url'],
+            number=result['number'],
+            assignee=result['assignee'],
+            timestamp=arrow.get(result['created_at']).timestamp,
+        )
+
+
+def _github_results(url, auth):
+    link = dict(next=url)
+    while 'next' in link:
+        response = requests.get(link['next'], params=auth)
+
+        # And.. if we didn't get good results, just bail.
+        if not bool(response):
+            raise IOError("Failed on %r %r" % (link['next'], response))
+
+        results = response.json()
+        for result in results:
+            yield result
+
+        field = response.headers.get('link', None)
+        link = dict()
+        if field:
+            link = dict([
+                (
+                    part.split('; ')[1][5:-1],
+                    part.split('; ')[0][1:-1],
+                ) for part in field.split(', ')
+            ])
diff --git a/hubs/utils/text.py b/hubs/utils/text.py
new file mode 100644
index 0000000..ad8fc55
--- /dev/null
+++ b/hubs/utils/text.py
@@ -0,0 +1,15 @@
+from __future__ import unicode_literals
+
+
+import markdown
+
+
+def markup(text):
+    return markdown.markdown(
+        text,
+        safe_mode="replace",
+        html_replacement_text="--RAW HTML NOT ALLOWED--")
+
+
+def commas(numeric):
+    return "{:,}".format(numeric)
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
new file mode 100644
index 0000000..2ceb399
--- /dev/null
+++ b/hubs/utils/views.py
@@ -0,0 +1,288 @@
+"""
+This module contains helper functions and classes for the views.
+"""
+
+from __future__ import unicode_literals
+
+import datetime
+import functools
+import logging
+
+import flask
+from six.moves.urllib import parse as urlparse
+from sqlalchemy.orm import joinedload
+from sqlalchemy.orm.exc import NoResultFound
+
+from hubs.models import Hub, Widget
+
+
+log = logging.getLogger(__name__)
+
+
+def get_hub(name, load_config=False, session=None):
+    """ Utility shorthand to get a hub and 404 if not found. """
+    if session is None:
+        session = flask.g.db
+    query = session.query(Hub).filter(Hub.name == name)
+    if load_config:
+        query = query.options(joinedload(Hub.config))
+    try:
+        return query.one()
+    except NoResultFound:
+        flask.abort(404)
+
+
+def get_widget_instance(hub, idx, session=None):
+    """ Utility shorthand to get a widget and 404 if not found. """
+    if session is None:
+        session = flask.g.db
+    try:
+        idx = int(idx)
+    except (TypeError, ValueError):
+        flask.abort(400)
+    try:
+        return session.query(Widget).join(Hub).filter(
+                Hub.name == hub,
+                Widget.idx == idx,
+            ).one()
+    except NoResultFound:
+        flask.abort(404)
+
+
+def get_visible_widgets(hub):
+    from hubs.widgets import registry
+    widgets = {"left": [], "right": []}
+    try:
+        user = flask.g.auth.user
+    except AttributeError:
+        user = None
+    for widget in hub.widgets:
+        if widget.plugin not in registry:
+            continue  # disabled widget
+        if not widget.allows(user, "view"):
+            continue
+        if widget.left:
+            widgets["left"].append(widget)
+        else:
+            widgets["right"].append(widget)
+    widgets["left"].sort(key=lambda w: w.index)
+    widgets["right"].sort(key=lambda w: w.index)
+    return widgets
+
+
+class WidgetConfigError(Exception):
+    pass
+
+
+def create_widget_instance(hub, widget, position):
+    """View helper to instanciate a widget on a hub.
+
+    Arguments:
+        hub (hubs.models.Hub): Instance of the hub to create the widget in.
+        widget (hubs.widgets.base.Widget): Widget to instanciate.
+        position (str): either ``left`` or ``right``.
+    """
+    widget_instance = Widget(
+        hub=hub, plugin=widget.name, index=-1,
+        left=(position == 'left'))
+    flask.g.db.add(widget_instance)
+    flask.g.db.flush()  # will populate Widget.config
+    try:
+        configure_widget_instance(widget_instance)
+    except WidgetConfigError as e:
+        flask.flash(e.args[0], "error")
+    else:
+        flask.flash("The widget has been added.")
+
+
+def configure_widget_instance(widget_instance):
+    """Configure a widget instance using the request form data.
+
+    Arguments:
+        widget_instance (hubs.models.Widget): Instance of the widget that is to
+            be configured.
+    """
+    config = {}
+    for param in widget_instance.module.get_parameters():
+        val = flask.request.form.get(param.name)
+        if not val:
+            raise WidgetConfigError(
+                'You must provide a value for: %s' % param.name)
+        try:
+            config[param.name] = param.validator.from_string(val)
+        except ValueError as err:
+            raise WidgetConfigError('Invalid data provided, error: %s' % err)
+    # Updating in-place is not supported, it's a class property.
+    cur_config = widget_instance.config or {}
+    cur_config = cur_config.copy()
+    cur_config.update(config)
+    widget_instance.config = cur_config
+    # Set the visibility parameter.
+    try:
+        widget_instance.visibility = flask.request.form["visibility"]
+    except KeyError:
+        pass  # the value is optional.
+    # Update the hub's mtime.  TODO: use a SQLAlchemy signal here.
+    widget_instance.hub.last_edited = datetime.datetime.utcnow()
+    try:
+        flask.g.db.commit()
+    except Exception as err:
+        log.warn(
+            "Could not save the configuration of widget "
+            "%s to the database: %s.",
+            widget_instance.idx, err)
+        raise WidgetConfigError(
+            'Could not save the configuration to the database '
+            'if the error persists, please warn an admin')
+
+
+def authenticated():
+    """ Utility function checking if the current auth is set or not."""
+    return hasattr(flask.g, 'auth') \
+        and flask.g.auth is not None \
+        and flask.g.auth.logged_in
+
+
+def login_required(function):
+    """ Flask decorator to restrict access to logged-in users. """
+
+    @functools.wraps(function)
+    def decorated_function(*args, **kwargs):
+        """ Decorated function, actually does the work. """
+        if not authenticated():
+            return flask.redirect(flask.url_for(
+                'login', next=flask.request.url))
+
+        return function(*args, **kwargs)
+
+    return decorated_function
+
+
+def require_hub_access(action, url_param="name", json=False):
+    """Check access to the hub for the specified action."""
+    def decorator(function):
+        @functools.wraps(function)
+        def wrapper(*args, **kwargs):
+            hub_name = kwargs[url_param]
+            hub = get_hub(hub_name, load_config=True)
+            try:
+                user = flask.g.auth.user
+            except AttributeError:
+                user = None
+            if not hub.allows(user, action):
+                if action == "view":
+                    msg = "This hub is for members only."
+                elif action == "config":
+                    msg = "You are not allowed to configure this hub."
+                else:
+                    msg = "Access forbidden."
+                if json:
+                    result = flask.jsonify({
+                        "status": "ERROR", "message": msg, "hub": hub.name,
+                        })
+                else:
+                    result = flask.render_template(
+                        'errors/hub.html', hub=hub, msg=msg,
+                        )
+                return result, 403
+            return function(*args, **kwargs)
+        return wrapper
+    return decorator
+
+
+def is_safe_url(target):
+    """ Checks that the target url is safe and sending to the current
+    website not some other malicious one.
+    """
+    ref_url = urlparse.urlparse(flask.request.host_url)
+    test_url = urlparse.urlparse(
+        urlparse.urljoin(flask.request.host_url, target))
+    return test_url.scheme in ('http', 'https') and \
+        ref_url.netloc == test_url.netloc
+
+
+def get_position():
+    # Use request.values instead of request.form to allow the position to be
+    # passed in the query string.
+    position = flask.request.values.get('position', '')
+    if position not in ['right', 'left']:
+        flask.abort(400, 'Invalid position provided')
+    return position
+
+
+class RequestValidator(object):
+    """Validate a request's POST data.
+
+    Instantiate this class with a dictionnary mapping POST data keys (found in
+    ``flask.request.form``) to a function that will validate and convert them.
+
+    POST data can be validated by calling the instance and passing the data as
+    an argument.  The instance will return a mapping of keys to converted
+    values if all validations are successful.
+
+    A validation function can raise a :py:exc:`ValueError` if the value is not
+    valid. In this case, the :py:class:`RequestValidator` instance will collect
+    the error messages in a dictionary mapping failed request keys to messages,
+    and raise a :py:exc:`ValueError` with this dictionary.
+
+    If the function is None, the value is returned unchanged. If a posted value
+    is not present in the conversion mapping the class was instantiated with,
+    an error will be raised.
+
+    A typical usage of this class is::
+
+        validator = RequestValidator({"number": int})
+        try:
+            values = validator(flask.request.form)
+        except ValueError as e:
+            failed_fields = e.args[0]
+            return flask.jsonify(failed_fields), 400
+        # Do something with the validated values.
+        for key, value in values.items():
+            setattr(model_instance, key, value)
+
+    In this example:
+
+    - if the posted data was ``number=1``, the resulting ``values`` variable
+      would be ``{"number": 1}``.
+    - if the posted data was ``number=foobar``, a :py:exc:`ValueError` would be
+      raised, ``failed_fields`` would be ``{"number": "error message"}``.
+    - if the posted data was ``foo=bar``, a :py:exc:`ValueError` would be
+      raised, ``failed_fields`` would be
+      ``{"foo": "message about unexpected key"}``.
+
+    Args:
+        converters (dict): a mapping from POST data keys to
+            conversion functions.
+    """
+
+    def __init__(self, converters):
+        self.converters = converters.copy()
+
+    def __call__(self, request_data):
+        """Convert the values in the given mapping.
+
+        Args:
+            request_data (dict): the values to validate and convert,
+                usually ``flask.request.form``.
+
+        Raises:
+            ValueError: At least one value is invalid.
+        """
+        values = {}
+        errors = {}
+        for key, value in request_data.items():
+            if key not in self.converters:
+                errors[key] = "Unexpected parameter."
+                continue
+            if self.converters[key] is None:
+                # Identity
+                values[key] = value
+                continue
+            try:
+                values[key] = self.converters[key](value)
+            except (TypeError, ValueError) as e:
+                errors[key] = e.args[0]
+        if errors:
+            raise ValueError(errors)
+        return values
diff --git a/hubs/views/api.py b/hubs/views/api.py
index 777bcda..b1232a5 100644
--- a/hubs/views/api.py
+++ b/hubs/views/api.py
@@ -5,7 +5,7 @@ import flask
 import hubs.models
 
 from hubs.app import app
-from .utils import get_hub, login_required
+from hubs.utils.views import get_hub, login_required
 
 
 @app.route('/api/hub/<hub>/subscribe', methods=['POST'])
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index d6d05f7..adcf65e 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -5,7 +5,7 @@ import flask
 import hubs.models
 
 from hubs.app import app
-from .utils import (
+from hubs.utils.views import (
     get_hub, get_visible_widgets, login_required, RequestValidator,
     require_hub_access,
     )
diff --git a/hubs/views/root.py b/hubs/views/root.py
index 74215da..be77ce6 100644
--- a/hubs/views/root.py
+++ b/hubs/views/root.py
@@ -4,7 +4,7 @@ import flask
 import hubs.models
 
 from hubs.app import app, OIDC
-from .utils import authenticated, is_safe_url
+from hubs.utils.views import authenticated, is_safe_url
 
 
 @app.route('/')
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 8c640af..0397b69 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -6,7 +6,7 @@ import hubs.models
 import hubs.stream
 
 from hubs.app import app
-from .utils import (
+from hubs.utils.views import (
     login_required, get_hub, get_visible_widgets, require_hub_access,
     )
 
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 35fb12a..2cd7f98 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -5,7 +5,7 @@ import flask
 from hubs.app import app
 from hubs.widgets import registry
 from pkg_resources import resource_isdir
-from .utils import (
+from hubs.utils.views import (
     create_widget_instance, configure_widget_instance, get_hub,
     get_widget_instance, login_required, WidgetConfigError,
     get_position, require_hub_access,
diff --git a/hubs/widgets/contact/__init__.py b/hubs/widgets/contact/__init__.py
index 1596cea..59b7a1d 100644
--- a/hubs/widgets/contact/__init__.py
+++ b/hubs/widgets/contact/__init__.py
@@ -6,7 +6,7 @@ import requests
 import six
 
 from hubs.widgets.base import Widget, WidgetView
-from hubs.views.utils import login_required
+from hubs.utils.views import login_required
 
 
 class Contact(Widget):
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 56f5e40..afcdf2e 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -5,7 +5,8 @@ import fedmsg.config
 import fedmsg.meta
 import requests
 
-from hubs.utils import get_fedmsg_config, commas
+from hubs.utils import get_fedmsg_config
+from hubs.utils.text import commas
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 283a15d..2de11a3 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -1,9 +1,9 @@
 from __future__ import unicode_literals
 
 import logging
-import hubs.utils
 
 from hubs.utils import get_fedmsg_config
+from hubs.utils.github import github_repos, github_pulls
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
@@ -63,9 +63,9 @@ class GetPRs(CachedFunction):
         displayed_number = 0
         more = 0
         if token:
-            repos = hubs.utils.github_repos(token, org)
+            repos = github_repos(token, org)
             pulls = sum([
-                list(hubs.utils.github_pulls(token, org, repo))
+                list(github_pulls(token, org, repo))
                 for repo in repos
             ], [])
             # Reverse-sort by time (newest-first)
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 2b5b2b4..eaa46ac 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -7,7 +7,7 @@ import flask
 from flask.signals import template_rendered
 
 from hubs.models import Hub
-from hubs.views.utils import get_hub, require_hub_access
+from hubs.utils.views import get_hub, require_hub_access
 from hubs.widgets import registry
 from hubs.widgets.base import WidgetView
 from .functions import GetRequests
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index b737f0a..68c26b9 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -5,7 +5,7 @@ import collections
 import datetime
 import requests
 
-from hubs import utils
+from hubs.utils.text import markup
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
@@ -65,7 +65,7 @@ class GetMeetings(CachedFunction):
         tmp = collections.defaultdict(list)
         for meeting in response['meetings']:
             if meeting.get('meeting_information_html'):
-                meeting['meeting_information_html'] = utils.markup(
+                meeting['meeting_information_html'] = markup(
                     meeting['meeting_information'])
             tmp[meeting['meeting_name']].append(meeting)
 
diff --git a/hubs/widgets/stats/__init__.py b/hubs/widgets/stats/__init__.py
index 67740df..b139175 100644
--- a/hubs/widgets/stats/__init__.py
+++ b/hubs/widgets/stats/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import flask
 
-from hubs.utils import commas
+from hubs.utils.text import commas
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 65d91c5..cd2810f 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -93,7 +93,7 @@ class WidgetView(View):
         }
 
     def _get_instance(self, *args, **kwargs):
-        from hubs.views.utils import get_widget_instance
+        from hubs.utils.views import get_widget_instance
         hubname = kwargs.pop("hub")
         widgetidx = kwargs.pop("idx")
         return get_widget_instance(hubname, widgetidx)

